<?xml version='1.0' encoding='ISO-8859-1'?> 
<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:xl="http://www.w3.org/1999/xlink"
xmlns:d="http://docbook.org/ns/docbook"
exclude-result-prefixes="d"
version="1.0">
<!--
module :
transformation docbook en un tracwiki 

original location :
/Users/fplod/SAXO_DIR_ws/SRC/Documentation/xmldoc/saxo_trackwiki.xsl sur aedon.locean-ipsl.upmc.fr

must be followed by awk -f saxo_trackwiki.awk
because I did not yet correctly handle "* text" (with no linefeed)
update :
$Id$
++
++ voir http://trac-hacks.org/wiki/XsltMacro
fplod 2008-04-18T13:01:50Z aedon.locean-ipsl.upmc.fr (Darwin)
pompage de href="http://docbook.sourceforge.net/release/xsl/current/html/xref.xsl
fplod 2008-01-08T16:05:29Z aedon.locean-ipsl.upmc.fr (Darwin)
a commence  prndre tournure
fplod 2007-10-19T08:39:15Z aedon.locean-ipsl.upmc.fr (Darwin)
creation 
cf http://forge.ipsl.jussieu.fr/superbib/wiki/WikiFormatting
et http://www.sagehill.net/docbookxsl/CustomDb5Xsl.html
car 1re xsl pour db5
-->


<!--
xml output with no xml declaration : this is the only way to make xsl:copy-of copy
nodes instead of contents of nodes
-->
<xsl:output method="xml" 
indent="no" 
omit-xml-declaration="yes"/>

<xsl:strip-space elements="d:article d:sect1 d:sect2 d:sect3 d:sect4 d:variablellist d:itemizedlist d:listitem d:varlistentry d:term d:para d:simpara"/>

<xsl:template match="/">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:article/d:title">
<!-- pour ajouter une table des matires 
d'aprs
http://groups.google.com/group/trac-users/browse_thread/thread/2c2cf9830c190a7d#e0a71ce3da67fb53
-->
 <xsl:text>= </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> =</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>[[PageOutline]]</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect1/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ==</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect2/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>=== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ===</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect3/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>==== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect4/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>===== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> =====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect5/title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>====== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ======</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:sect2/d:simplesect/d:title">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>==== </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text> ====</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:systemitem">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:simpara">
 <xsl:text>&#xA;</xsl:text>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:para/d:command">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:filename">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:varname">
 <xsl:text>{{{</xsl:text><xsl:value-of select="."/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:literallayout">
 <xsl:text>{{{</xsl:text><xsl:apply-templates/><xsl:text>}}}</xsl:text>
</xsl:template>

<xsl:template match="d:screen">
 <!-- 
we open an HTML block because it is not possible to have font effect (bold, italic)
using TracWiki
 -->
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!html</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <pre class="screen">
 <xsl:apply-templates/>
 </pre>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:screen/d:prompt">
<code class="prompt"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:userinput">
<strong class="userinput"><code><xsl:apply-templates/></code></strong>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:command">
<span><strong class="command"><xsl:value-of select="."/></strong></span>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:option">
<code class="option"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:computeroutput">
<code class="computeroutput"><xsl:value-of select="."/></code>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:parameter">
<em class="parameter"><code><xsl:apply-templates/></code></em>
</xsl:template>

<xsl:template match="d:screen/d:userinput/d:parameter/d:replaceable">
<code class="replaceable"><xsl:value-of select="."/></code>
</xsl:template>


<xsl:template match="d:blockquote">
  <xsl:text>  </xsl:text><xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:itemizedlist/d:listitem/d:simpara/d:link[@xl:href]">
 <xsl:text> [</xsl:text><xsl:value-of select="@xl:href"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:variablelist/d:varlistentry/d:listitem/d:simpara/d:link[@xl:href]">
 <xsl:text> [</xsl:text><xsl:value-of select="@xl:href"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:quote">
  <xsl:text>"</xsl:text><xsl:value-of select="."/><xsl:text>"</xsl:text>
</xsl:template>

<xsl:template match="d:itemizedlist/d:listitem">
 <xsl:text>&#xA;</xsl:text>
 <xsl:text> @star@ </xsl:text><xsl:apply-templates/>
</xsl:template>

<xsl:template match="d:imagedata[@fileref]">
<!--
ex : [[Image(source:/trunk/SRC/Documentation/xmldoc/images/showfig.png)]] 
-->
<xsl:text>[[Image(source:/trunk/SRC/Documentation/xmldoc/</xsl:text><xsl:value-of select="@fileref"/><xsl:text>)]]</xsl:text>
</xsl:template>

<xsl:template match="d:link[contains(@xl:href,'idldoc_html_output')]">
 <xsl:text>[http://forge.ipsl.jussieu.fr/saxo/download/idldoc_html_output/</xsl:text>
<xsl:message><xsl:value-of select="substring-after(@xl:href,'idldoc_html_output/')"/></xsl:message>
<xsl:message>++Download</xsl:message>
<!-- ++
<xsl:value-of select="substring-after(@xl:href,'idldoc_html_output/')"/>
-->
<xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:link[contains(@xl:href,'idlfiles/')]">
 <xsl:message>++idlfiles</xsl:message>
 <xsl:text>[source:/trunk/SRC/Documentation/idlfiles/</xsl:text><xsl:value-of select="substring-after(@xl:href,'idlfiles/')"/> <xsl:value-of select="normalize-space(.)"/><xsl:text>]</xsl:text>
</xsl:template>


<xsl:template match="d:para/d:link[@xl:href]">
<xsl:variable name="wikilink">
 <xsl:choose>
  <xsl:when test="contains(@xl:href,'firststeps.html')">
   <xsl:text>wiki:FirstSteps</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'all_plots.html')">
   <xsl:text>wiki:AllPlots</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'faqsaxo.html')">
   <xsl:text>wiki:FaqSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'getsaxo.html')">
   <xsl:text>wiki:GetSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'infoupdatecm.html')">
   <xsl:text>wiki:InfoUpdateCm</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'infoupdatekwd.html')">
   <xsl:text>wiki:InfoUpdateKwd</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'mailing.html')">
   <xsl:text>wiki:Mailing</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'mini_notice.html')">
   <xsl:text>wiki:MiniNotice</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'tiplink.html')">
   <xsl:text>wiki:TipLink</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'updatesaxo.html')">
   <xsl:text>wiki:UpdateSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'whatissaxo.html')">
   <xsl:text>wiki:WhatisSaxo</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'whatsnew.html')">
   <xsl:text>wiki:WhatsNew</xsl:text>
  </xsl:when>
  <xsl:when test="contains(@xl:href,'websaxo.html')">
   <xsl:text>wiki:WikiStart</xsl:text>
  </xsl:when>
  <xsl:otherwise>
   <xsl:value-of select="@xl:href"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:variable>
<xsl:text>[</xsl:text><xsl:value-of select="$wikilink"/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:quote">
  <xsl:text>"</xsl:text><xsl:value-of select="."/><xsl:text>"</xsl:text>
</xsl:template>

<xsl:template match="d:email">
<xsl:text>[mailto:</xsl:text><xsl:value-of select="."/> <xsl:text> </xsl:text><xsl:value-of select="."/> <xsl:text>]</xsl:text>
</xsl:template>

<xsl:template match="d:variablelist/d:varlistentry/d:term">
 <xsl:text>'''</xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text>'''</xsl:text>
</xsl:template>

<xsl:template match="d:emphasis">
  <xsl:text>''</xsl:text><xsl:value-of select="."/><xsl:text>''</xsl:text>
</xsl:template>

<xsl:template match="d:replaceable">
<!--
+++ pas de ''' dans un truc qui est entre {{{...}}}
-->
  <xsl:text>'''''</xsl:text><xsl:value-of select="."/><xsl:text>'''''</xsl:text>
</xsl:template>

<xsl:template match="d:superscript">
  <xsl:text>^</xsl:text><xsl:value-of select="."/><xsl:text>^</xsl:text>
</xsl:template>

<xsl:template match="d:subscript">
  <xsl:text>,,</xsl:text><xsl:value-of select="."/><xsl:text>,,</xsl:text>
</xsl:template>

<xsl:template match="d:simplelist">
<!-- but beware of links inside -->
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:informaltable">
<!-- but beware of links inside -->
 <xsl:text>{{{</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>#!docbook</xsl:text>
 <xsl:text>&#xA;</xsl:text>
 <xsl:copy-of select="."/>
 <xsl:text>&#xA;</xsl:text>
 <xsl:text>}}}</xsl:text>
 <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="d:xref"> 
  <xsl:variable name="target" select="key('id',@linkend)[1]"/>
  <xsl:text>[#</xsl:text><xsl:value-of select="normalize-space(//d:sect1[normalize-space(@xml:id='$target')]/d:title)"/><xsl:text>]</xsl:text>
</xsl:template>

<!-- do not reproduce the followings elements -->
<xsl:template match="d:mediaobject/d:textobject"/>
<xsl:template match="d:info/d:authorgroup"/>
<xsl:template match="d:info/d:revhistory"/>
<xsl:template match="d:info/d:pubdate"/>
<xsl:template match="d:keywordset"/>

</xsl:stylesheet>  
